#include <iostream>
 #include <string>
 #include <vector>
 #include <set>
 #include <map>
 #include <algorithm>
 
 using namespace std;
 
 #define uint unsigned int
 
 #define FOR(i, n) for (int i = 0; i < (n); i++)
 #define FORU(i, n) for (uint i = 0; i < (n); i++)
 #define FORR(i, n) for (int i = (n)-1; i >= 0; i--)
 #define FORRU(i, n) for (uint i = (n)-1; i >= 0; i--)
 #define FOREACH(it, v) for (__typeof__(v.begin()) it = (v).begin(); it != (v).end(); ++it)
 
 typedef struct _chick {
     double x;
     double v;
 } chick;
 
 int cmp(const chick *a, const chick *b) {
     if (a->x == b->x) return 0;
     if (a->x < b->x) return -1;
     return 1;
 }
 
 int main() {
     int cases;
     cin >> cases;
 
     FOR(tcase, cases) {
         int n, k, b, t;
         chick chicks[100];
 
         cin >> n >> k >> b >> t;
 
         FOR(i, n) {
             cin >> chicks[i].x;
         }
         FOR(i, n) {
             cin >> chicks[i].v;
         }
 
         int finish = 0;
         FOR(i, n) {
             if (t * chicks[i].v + chicks[i].x >= b) finish++;
         }
 
         if (finish < k) {
             printf("Case #%d: IMPOSSIBLE\n", tcase+1);
             continue;
         }
 
         // qsort(chicks, n, sizeof(chick), (int(*)(const void *, const void *)) cmp);
 
         int swaps = 0;
         FOR(i, n) {
             for (int j = i+1; j < n; j++) {
                 if (chicks[i].v > chicks[j].v) {
                     double z = (chicks[j].x - chicks[i].x) / (chicks[i].v - chicks[j].v);
                     double o = chicks[i].x + chicks[i].v * z;
                     if (z <= t && o < b &&
                             o + chicks[j].v * (t - z) < b &&
                             o + chicks[i].v * (t - z) >= b) {
                         // fprintf(stderr, "FOO: %d -> %d\n", (int) chicks[i].x, (int) chicks[j].x);
                         swaps++;
                     }
                 }
             }
         }
 
         printf("Case #%d: %d\n", tcase+1, swaps);
     }
 
     return 0;
 }
