#include <stdio.h>
 #include <iostream>
 #include <iomanip>
 #include <fstream>
 #include <cstdlib>
 using namespace std;
 
 long find_next(long n, long *x, long *pw, long c) {
 	long next = -1;
 	for ( long i = 0; i < n; i++ ) {
 		if ( i == c ) continue;
 		if ( pw[i] == 1 ) continue;
 
 		//cout << "comparing " << c << " " << x[c] << " with " << i << " " << x[i] << endl;
 
 		if ( x[i] > x[c] ) {
 			if ( next == -1 )	
 				next = i;
 			else if ( x[next] > x[i] )
 				next = i;
 		}
 	}
 	return next;
 }
 
 int main(int argc, char *argv[]) {
 	ifstream in;
 	if ( argc >=1 )
 		in.open(argv[1]);
 	else
 		in.open("B-small.in");
 
 	if (!in) {
 		cout << "file open failed";
 		exit(1);
 	}
 	
 	long problems = 0;
 
 	in >> problems;
 	long n, k, t, v[50];
 	long b, x[50],xx[50];
 
 	for ( long p = 1; p <= problems; p++ ) {
 		in >> n;
 		in >> k;
 		in >> b;
 		in >> t;
 		for ( long i = 0; i < n; i++ )
 			in >> xx[i];
 		for ( long i = 0; i < n; i++ )
 			in >> v[i];
 
 		long swaps = 0;
 		long passed = 0;
 		long pw[50];
 		for ( long i = 0; i < 50; i++ ) pw[i] = 0;
 		long j = 0;
 
 		long savail = 0;
 		long swapping = -1;
 		long done = 0;
 
 		while ( done == 0 ) {
 			swaps = 0;
 			swapping++;
 			//cout << "begin run, swaps: " << swapping << endl;
 			savail = swapping;
 			passed = 0;
 		for ( long i = 0; i < n; i++ ) {
 			x[i] = xx[i];
 			pw[i] = 0;
 		}
 
 		for ( long time = 0; time <= t; time++ ) {
 			for ( long nn = 0; nn < n; nn++ ) {
 				if ( pw[nn] == 1 ) continue;
 				long next = find_next(n, &x[0], &pw[0], nn);
 
 				if ( next > 0 && x[next] == x[nn] + 1 ) {
 					// this is a swap option IF THE VELOCITIES ARE DIFFERENT
 //					cout << "side by side" << endl;
 					if ( v[next] < v[nn] ) {
 						//cout << "swap available" << endl;
 						swaps++;
 						if ( savail > 0 ) {
 							//cout << "swapping" << endl;
 							savail--;
 							x[next] = x[nn];
 							x[nn] = x[next]+1;
 							continue;
 						}
 					}
 				}
 			}
 			for ( long nn = n-1; nn >= 0 ; nn-- ) {
 				if ( pw[nn] == 1 ) continue;
 				long next = find_next(n, &x[0], &pw[0], nn);
 
 				if ( next > 0 && x[next] <= x[nn] + v[nn] ) {
 					x[nn] = x[next]-1;
 				} else 
 					x[nn] += v[nn];
 
 				if ( x[nn] >= b ) {
 					passed++;
 					pw[nn] = 1;
 				}
 			}
 		}
 
 			if ( passed < k ) {
 				if ( swapping >= swaps ) 
 					done = -1;
 			} else done = 1;
 
 		}
 
 
 		if ( done == 1 )
 			cout << "Case #" << p << ": " << swapping;
 		else
 			cout << "Case #" << p << ": IMPOSSIBLE";
 		cout << endl;
 	}
 }
