#include <iostream>
 #include <cstring>
 using namespace std;
 
 const int MAXN = 60;
 struct node{
 	int d, v;
 	node(int a = 0, int b = 0) : d(a), v(b){
 	}
 } data[MAXN];
 double t[MAXN];
 int n, k, b, tm;
 void calc(node *data){
 	memset(t, 0, sizeof(t));
 	for (int i = 0; i < n; ++i){
 		t[i] = (double)data[i].d / data[i].v;
 	}
 	for (int i = n - 2; i >= 0; --i){
 		if (data[i].v == data[i + 1].v) continue;
 		double temp = (data[i].d - data[i + 1].d + 0.0) / (data[i].v - data[i + 1].v);
 		if (temp > 0 && temp < t[i + 1]){
 			t[i] = t[i + 1];
 		}
 	}
 }
 
 int work(int x){
 	node temp[MAXN];
 	memcpy(temp, data, sizeof(data));
 	int ret = 0;
 	int pos = x - 1;
 	while (pos >= 0){
 		swap(temp[x].v, temp[pos].v);
 		++ret;
 		calc(temp);
 		if (t[x] < tm + 1e-8){
 			node a = data[pos];
 			for (int i = pos; i <= x - 1; ++i){
 				data[i].v = data[i + 1].v;
 			}
 			data[x].v = a.v;
 			return ret;
 			
 		} else {
 			swap(temp[x].v, temp[pos].v);
 			--pos;
 		}
 	}
 	return -1;
 }
 int main(){
 	int cases;
 	cin >> cases;
 	for (int tt = 0; tt < cases; ++tt){
 		cin >> n >> k >> b >> tm;
 		//cout << tm << endl;
 		memset(data, 0, sizeof(data));
 		for (int i = 0; i < n; ++i){
 			int x; cin >> x;
 			data[i].d = b - x;
 		}
 		for (int i = 0; i < n; ++i){
 			int x; cin >> x;
 			data[i].v = x;
 		}
 		calc(data);
 		int ans = 0;
 		bool nosolution = false;
 	//	while (true){
 			/*for (int i = n - 1; i >= 0; --i){
 				cout << t[i] << " ";
 			}
 			cout << endl;*/
 			bool ok = true;
 			for (int i = n - 1; i > n - 1 - k; --i){
 				if (t[i] > tm){
 					if (i == 0){
 						nosolution = true;
 						break;
 					}
 					int temp = work(i);
 					if (temp == -1){
 						nosolution = true;
 						break;
 					}
 					ans += temp;
 					ok = false;
 					break;
 				}
 			}
 			for (int i = n - 1; i > n - 1 - k; --i){
 				if (t[i] > tm){
 					nosolution = true;
 					break;
 				}
 			}
 		//	if (nosolution || ok) break;
 		//	calc(data);
 		//}
 		printf("Case #%d: ", tt + 1);
 		if (nosolution) puts("IMPOSSIBLE"); else printf("%d\n", ans);
 	}
 	return 0;
 }