// @author kelvin
 // #includes {{{
 #include <cstdio>
 #include <cstdlib>
 #include <cassert>
 #include <iostream>
 #include <vector>
 #include <algorithm>
 #include <cstring>
 #include <string>
 #include <set>
 #include <queue>
 #include <sstream>
 using namespace std;
 // }}}
 // #defines {{{
 #define MP(x,y) make_pair(x,y)
 #define PB(x) push_back(x)
 #define POP() pop_back()
 #define F first
 #define S second
 #define PR printf
 void RI() {}
 template<typename... T>
 void RI(int& head,T&... tail) {
     scanf("%d",&head);
     RI(tail...);
 }
 void PRI(int x) {
     printf("%d\n",x);
 }
 template<typename... Args>
 void PRI(int head,Args... tail) {
     printf("%d ",head);
     PRI(tail...);
 }
 #define RF(x) scanf("%lf",&(x))
 #define RS(x) scanf("%s",x)
 #define DPRI(x) fprintf(stderr,"<"#x"=%d>\n",x)
 #define DPRII(x,y) fprintf(stderr,"<"#x"=%d, "#y"=%d>\n",x,y)
 #define DPRIII(x,y,z) fprintf(stderr,"<"#x"=%d, "#y"=%d, "#z"=%d>\n",x,y,z)
 #define DPRIIII(x,y,z,w) fprintf(stderr,"<"#x"=%d, "#y"=%d, "#z"=%d "#w"=%d>\n",x,y,z,w)
 #define DPRF(x) fprintf(stderr,"<"#x"=%lf>\n",x)
 #define DPRS(x) fprintf(stderr,"<"#x"=%s>\n",x)
 #define DPRMSG(x) fprintf(stderr,#x"\n")
 #define DPRPII(x) fprintf(stderr,"<"#x"=(%d,%d)>\n",x.F,x.S)
 typedef pair<int,int> pii;
 // }}}
 // #functions {{{
 pii operator+(const pii &a,const pii &b) { return MP(a.F+b.F,a.S+b.S); }
 pii operator-(const pii &a,const pii &b) { return MP(a.F-b.F,a.S-b.S); }
 pii& operator+=(pii &a,const pii &b) { a.F+=b.F; a.S+=b.S; return a; }
 pii& operator-=(pii &a,const pii &b) { a.F-=b.F; a.S-=b.S; return a; }
 template <class T,class U>
 bool cmp_second(const pair<T,U> &a,const pair<T,U> &b) { return a.second<b.second; }
 template <class T>
 T gcd(T a,T b) { a=abs(a); b=abs(b); while(b) { T t=b; b=a%b; a=t; } return a; }
 template <class T>
 pair<T,T> ext_gcd(T a,T b) {
    T a0=1,a1=0,b0=0,b1=1;
    if(a<0) { a=-a; a0=-1; }
    if(b<0) { b=-b; b1=-1; }
    while(b) {
       T t,q=a/b;
       t=b; b=a-b*q; a=t;
       t=b0; b0=a0-b0*q; a0=t;
       t=b1; b1=a1-b1*q; a1=t;
    }
    return MP(a0,a1);
 }
 inline string concatenate_strings(vector<string> ss) {
    string s;
    for(int i=0;i<ss.size();i++)
       s+=ss[i];
    return s;
 }
 template <class T>
 inline vector<T> read_from_string(string s) {
    vector<T> ret; stringstream ss(s,stringstream::in);
    while(1) { T x; ss>>x; ret.push_back(x); if(ss.eof()) break; }
    return ret;
 }
 // }}}
 
 #define MAXL 10050
 
 const int inf=1000000;
 
 int n,mi,ma;
 int cmi[]={0,1,1,2,2,3,3};
 int cma[]={0,1,2,3,4,5,6};
 
 bool solve() {
     if(mi>ma) swap(mi,ma);
     if(mi*ma%n!=0) return 0;
     if(mi<cmi[n]) return 0;
     if(ma<cma[n]) return 0;
     if(n==1) return 1;
     if(n==2) return 1;
     if(n==3) return 1;
     if(n==4) return mi>2;
     if(n==5) return 1;
     if(n==6) return mi>3;
     return 0;
 }
 
 int main(void)
 {
     int t;
     RI(t);
     for(int cas=1;cas<=t;cas++) {
         RI(n,mi,ma);
         string sol=solve()?"GABRIEL":"RICHARD";
         printf("Case #%d: %s\n",cas,sol.c_str());
     }
     return 0;
 }
 
 // vim: fdm=marker:commentstring=//\ %s:nowrap:autoread
