
 // Jesse Pritchard
 // D-large code
 
 #include "stdio.h"
 #include "stdlib.h"
 #include "math.h"
 
 //#define USE_FILE
 
 #ifdef USE_FILE
 #define read_in(...) fscanf(f, __VA_ARGS__)
 #define write_out(...) fprintf(o, __VA_ARGS__)
 #else
 #define read_in scanf
 #define write_out printf
 #endif
 
 int main() {
 #ifdef USE_FILE
     FILE* f = fopen("input.txt", "r");
     FILE* o = fopen("out.txt", "w");
 #endif
     
     int num;
     read_in("%d", &num);
     int iii;
     for (iii = 0; iii < num; iii++) {
         int X, R, C;
         read_in(" %d %d %d", &X, &R, &C);
         int det = (X + 1.0) / 2;
         if (R*C % X != 0 || (X > R && X > C) || X >= 7 || det > R || det > C) {
             write_out("Case #%d: RICHARD\n", iii + 1);
         }
         else if ((X > R && X <= C) || (X > C && X <= R)) {
             int spanned = R > C ? C : R;
             int other = R > C ? R : C;
             int extra = X - spanned;
             int space = R * C - X;
             /* If it is possible, for every 0 < iii <= extra, that 
              (spanned * x - iii) % X == 0 && 
              ((spanned * (other - x - 1) - (extra - iii)) % X == 0 
              for some 0 < x < other, Gabriel can still win */
             
             int kkk, jjj;
             for (kkk = 0; kkk <= extra; kkk++) {
                 for (jjj = 0; jjj < other; jjj++) {
                     if ((spanned * jjj - kkk) % X == 0 && (spanned * (other - jjj - 1) - (extra - kkk)) % X == 0) {
                         break;
                     }
                 }
                 if (jjj == other) {
                     break;
                 }
             }
             if (kkk == extra + 1) {
                 write_out("Case #%d: GABRIEL\n", iii + 1);
             }
             else {
                 write_out("Case #%d: RICHARD\n", iii + 1);
             }
         }
         else write_out("Case #%d: GABRIEL\n", iii + 1);
     }
     
 #ifdef USE_FILE
     fclose(f);
     fclose(o);
 #endif
     
     return 0;
 }
