#include<stdio.h>
 
 #define MIN(x,y) (x<y ? x : y)
 #define MAX(x,y) (x>y ? x : y)
 
 int main() {
     int T;
     scanf("%d",&T); // Cases
 
     int t,j,n;
     for (t = 1; t <= T; t++) {
         int X,R,C;
         scanf("%d %d %d",&X, &R, &C); // Max shy
  
         // Board valid?
         int win;
         if (R*C % X != 0 && R*C != 0) {
             win = 1;
         } else {
             if      (X<=2) win = 0;
             else if (MIN(R,C) == 1)  win = 1;
             else if (X==3) win = 0;
             else if (X>=7) win = 1;
             else if (MIN(R,C) < (X+1)/2) win = 1;
             else {
                 if (X == 4) win = R*C <= 8;
                 if (X == 5) win = MIN(R,C)<=2;
                 if (X == 6) win = MIN(R,C)<=3;
             }
         }
 
 
         printf("Case #%d: %s\n",t,win ? "RICHARD" : "GABRIEL");
     }
 }
 
 //
 // Winning conditions.
 //      A piece with a hole
 //      Block with max side greater than boundary
 //      Block that just won't fit.
 //  
 // Assmuing a valid board:
 //  if X <= 2
 //      loss (no options)
 //
 //  if X >= 7
 //      win (hole)
 //
 //  if MIN(R,C) < (X+1)/2
 //      win (big block)
 //  
 //  [1 width ruled out!]
 //
 //  X=3
 //    Smallest:
 //    [xxx]
 //    [xxx]
 //
 //    Tilable, so screwed!
 //
 //  X=4
 //    Smallest:
 //        [xx]
 //        [xx]
 //
 //        Win
 //
 //        [xxxx]
 //        [xxxx]
 //
 //        Loss
 //
 //  X=5
 //    Smallest:
 //        [xxxxx]
 //        [xxxxx]
 //
 //        Win
 //
 //        [xxoxx]  ooooo  oooo  oooo  ooo  ooo   o   ooo   o     o
 //        [xxoox]            o    o     o   o   ooo  o o   ooo  ooo
 //        [xooxx]                       o   o    o           o  o
 //        
 //        Loss
 //
 //        [xxxxx] Loss
 //        [xxxxx]
 //        [xxxxx]
 //        [xxxxx]
 //        
 //        [xxxxxxxxxx] Win
 //        [xxxxxxxxxx]
 //
 //  X=6
 //     oooooo
 //
 //     ooooo
 //     o
 //
 //     ooooo
 //      o
 //
 //     ooooo
 //      o
 //
 //     ooooo
 //       o
 //
 //     oooo
 //     oo
 //
 //     oooo
 //     o o
 //
 //     oooo
 //     o  o
 //
 //     o
 //     oooo
 //     o
 //
 //      o
 //     oooo
 //     o
 //
 //       o
 //     oooo
 //     o
 //
 //        o
 //     oooo
 //     o
 //
 //      o
 //     oooo
 //      o
 //
 //       o
 //     oooo
 //      o
 //
 //     ooo
 //     ooo
 //     
 //     o
 //     ooo
 //     oo
 //
 //      o
 //     ooo
 //     oo
 //
 //       o
 //     ooo
 //     oo
 //
 //     o
 //     ooo
 //     o o
 //
 //      o
 //     ooo
 //     o o
 //
 //     
 //     ooo
 //       ooo
 //
 //     ooo
 //       oo
 //        o
 //
 //
 //     [xxx]
 //     [xxx] Win
 //
 //     [xxxxxx]
 //     [xxxxxx] Win
 //
 //     [xxxx]   
 //     [xxxx]
 //     [xxxx] Win
 //
 //     [xxxxox]
 //     [xoooox]
 //     [xxxoxx] Win
 //
 //       o
 //     oooo
 //     o
 //
 //     [oooxxx]
 //     [xxooxx]
 //     [xxxoxx]
 //     [xxxxxx] Loss
 //
 //     [xxxxxxxx]
 //     [xxxxxxxx]
 //     [xxxxxxxx] Win
 //
 // if 1xN
 //      win
 // else
 //      X = 3
 //          loss
 //      X = 4
 //          OO
 //          OO
 // 
 //
 //
 //
 //
 //
 //
