#include <iostream>
 #include <fstream>
 #include <cstring>
 using namespace std;
 
 
 ifstream fin;
 ofstream fout;
 
 
 int solve(int X, int R, int C)
 {
     int minrc = (R < C) ? R : C;
     int maxrc = (R > C) ? R : C;
     int rdotc = R * C;
 
     switch (X)
     {
     case 1:
         return 0;
     case 2:
         return rdotc % 2;
     case 3:
         if (rdotc % 3 != 0) return 1;
         if (minrc == 1) return 1;
         return 0;
     case 4:
         if (rdotc % 4 != 0) return 1;
         if (minrc <= 2) return 1;
         return 0;
     case 5:
         if (rdotc % 5 != 0) return 1;
         if (minrc <= 3 && maxrc == 5) return 1;
         return 0;
     case 6:
         if (rdotc % 6 != 0) return 1;
         if (minrc <= 3) return 1;
         return 0;
     default:
         return 1;
     }
 }
 
 
 int main()
 {
     fin.open("in.txt");
     fout.open("out.txt");
 
     int cases, ci;
     int ans;
     int X, R, C;
     fin >> cases;
     for (ci=1; ci<=cases; ci++)
     {
         cout << "Case " << ci << "...";
         fin >> X >> R >> C;
         ans = solve(X, R, C);
         if (ans)
             fout << "Case #" << ci << ": RICHARD" << endl;
         else
             fout << "Case #" << ci << ": GABRIEL" << endl;
         cout << "ok." << endl;
     }
 
     fin.close();
     fout.close();
     return 0;
 }
