
 #include <iostream>
 
 using namespace std;
 
 // size of the smaller dimension for GABRIEL to have a chance
 // for X ->   0  1  2  3  4  5  6
 int mins[] = {0, 1, 1, 2, 3, 3, 5};
 
 bool win(int X, int R, int C) {
 	if (X >= 7) return true;
 	if (R < C) return win(X, C, R);
 
 	// guaranteed to R >= C
 	//cout << X << ' ' << R << ' ' << C << " -> ";
 	if ((R * C) % X != 0) return true;
 	if (X > R) return true;
 	if (C < mins[X]) return true;
 	
 	return false;
 }
 
 int main() {
 	int T, X, R, C;
 	cin >> T;
 	for (int t = 1; t <= T; t++) {
 		cin >> X >> R >> C;
 		cout << "Case #" << t << ": " << (win(X, R, C) ? "RICHARD" : "GABRIEL") << endl;
 	}
 
 	return 0;
 }
 
