#include <iostream>
 #include <algorithm>
 
 using namespace std;
 
 bool gabrielWon(unsigned x, unsigned r, unsigned c) {
 	unsigned big = max(r,c);
 	unsigned small = min(r,c);
 	switch (x) {
 		case 1:
 			return true;
 		case 4:
 		case 5:
 		case 6:
 			if ((x+1)/2 == small) {
 				return false;
 			}
 		case 2:
 		case 3:
 			if ((x+1)/2 > small || x > big) { // richard can choose a piece that cannot fit in the box
 				return false;
 			}
 			if ((r*c) % x == 0) { // gabriel can pick pieces to fit around the forced one
 				return true;
 			}
 		default:
 			return false;
 	}
 }
 
 int main() {
 	unsigned t;
 	cin >> t;
 	for (unsigned caseNum = 1; caseNum <= t; caseNum++) {
 		unsigned x, r, c;
 		cin >> x;
 		cin >> r;
 		cin >> c;
 		cout << "Case #" << caseNum << ": ";
 		if (gabrielWon(x,r,c)) {
 			cout << "GABRIEL\n";
 		} else {
 			cout << "RICHARD\n";
 		}
 	}
 	return 0;
 }