#include <stdio.h>
 
 
 int main(int argc, char *argv[])
 {
     int t, t_index;
     FILE *ifp, *ofp;
 
     ifp = fopen("in.txt", "r");
     ofp = fopen("out.txt", "w");
 
     fscanf(ifp, "%d", &t);
     for (t_index = 1; t_index <= t; t_index++)
     {
         // Turn START
         fprintf(ofp, "Case #%d: ", t_index);
 
         int x, r, c;
         fscanf(ifp, "%d", &x);
         fscanf(ifp, "%d", &r);
         fscanf(ifp, "%d", &c);
 
         int min = r<c?r:c;
         int max = r>c?r:c;
 
             // case 1: there's no way to avoid blank spaces.
         if ((0 != r*c%x) ||
             // case 2: you can make a circle
             (7 <= x) ||
             // case 3: bigger area than what's awailable
             (((x+1)/2 > min) || (((x+1)/2+(x-1)%2) > max))
             )
         {
             fprintf(ofp, "RICHARD\n");
             continue;
         }
         else
         {
             // case 4: WARNING, THIS ONE IS WITH GABRIEL
             // If we have a border of 1 around the form, for sure Gabriel has the upper hand
             if (min >= x+2)
             {
                 fprintf(ofp, "GABRIEL\n");
                 continue;
             }
 
             // case 5: what's left from the area is not compatible
             if (max < x)
             {
                 int found = 0;
                 int k = 0;
                 while (k * max + max * (x + 1 - max) <= min * max) {
                     if ((k * max + (max - 1) * (x - max)) % x == 0) {
                         found = 1;
                         break;
                     }
                     k++;
                 }
                 if (!found) {
                     fprintf(ofp, "RICHARD\n");
                     continue;
                 }
             }
             // other cases
             if (((x == 4) && (min <= 2)) ||
                 ((x == 5) && (min <= 2)) ||
                 ((x == 6) && (min <= 3)))
             {
                 fprintf(ofp, "RICHARD\n");
                 continue;
             }
         }
         fprintf(ofp, "GABRIEL\n");
         // Turn END
     }
     fclose(ofp);
     fclose(ifp);
 	return 0;
 }
