#include <iostream>
 #include <cstdlib>
 
 using namespace std;
 
 bool solve(int x, int r, int c)
 {
 	switch(x) {
 	case 1:
 		return true;
 	case 2:
 		return ((r * c) % x == 0) && ((r >= x) || (c >= x));
 	case 3:
 		return ((r * c) % x == 0) && ((r >= x) || (c >= x)) && (r > 1) && (c > 1);
 	case 4:
 		return ((r * c) % x == 0) && ((r >= x) || (c >= x)) && (r > 2) && (c > 2);
 	}
 	return true;
 }
 
 bool solve2(int x, int r, int c)
 {
 	if((r * c) % x != 0) {
 		return false;
 	}
 	if((r < x) && (c < x)) {
 		return false;
 	}
 	int tmp = 1 + (x - 1) / 2;
 	if((r < tmp) || (c < tmp)) {
 		return false;
 	}
 	if((r >= x) && (c >= x)) {
 		return true;
 	}
 	if(min(r, c) > 1 && (x % min(r, c) == 0)) {
 		return false;
 	}
 	return true;
 }
 
 int main()
 {
 	int tests_num;
 	cin >> tests_num;
 	for(int t = 1; t <= tests_num; ++t) {
 		int x, r ,c;
 		cin >> x >> r >> c;
 		// if(solve(x, r, c) != solve2(x, r, c)) {
 		// 	cout << "Error: " << x << " " << r << " " << c << " " << solve2(x, r, c) << endl;
 		// }
 		cout << "Case #" << t << ": ";
 		if(solve2(x, r, c)) {
 			cout << "GABRIEL" << endl;
 		} else {
 			cout << "RICHARD" << endl;
 		}
 	}
 	return 0;
 }
