#include <iostream>
 #include <fstream>
 
 bool whoWin(int x, int r, int c) {
 	if (((r*c) % x) != 0) return false;
 	
 	if (x < 3) return true;
 	
 	if (x == 3) {
 		return r != 1 && c != 1;
 	}
 	
 	if (x == 4) {
 		if (c*r >=12) { //6*2 | 3*4 
 			return true;
 		}
 	}
 	
 	if (x == 5) {
 		if (c>= 5 && r >= 4)
 		return true;
 		if (r >= 5 && c >= 4)
 		return true;
 	}
 
 	// ..*
 	// .**
 	// **.
 		
 	if (x == 6) {
 		if (c >= 6 && r >= 4)
 			return true;
 		if (r >= 6 && c >= 4)
 			return true;
 	}
 
 	// .*.
 	// ***
 	// *.* 
 	
 	if (x > 6) return false;
 	
 	// ***
 	// *.*
 	// .**
 	
 	return false;
 }
 
 int main(int argc, char **argv) {
 	int n;
 	std::ifstream input;
 	std::ofstream output;
 	input.open("D-large.in");
 	output.open("out.txt");
 	input >> n;
 	for (int i = 1;i<=n;i++) {
 		int x;
 		input >> x;
 		int r;
 		input >> r;
 		int c;
 		input >> c;
 		bool winner = whoWin(x,r,c);
 		output << "Case #" << i << ": " << (winner?"GABRIEL":"RICHARD") << std::endl;
 	
 	}
     input.close();
 	output.close();
 	return 0;
 }
