#include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 
 int getNum(char *a);
 void copybuf(int *s, int *d);
 
 int main ()
 {
 	FILE *fin  = fopen ("A-small-attempt1.in", "r");
     
     int i, numTestCases;
     
     char buffer[1024];
     
     int board1[4][4] = {{0}};
     int board2[4][4] = {{0}};
 
     fgets(buffer, 1024, fin);
     sscanf(buffer, "%d", &numTestCases);
     
     int k;
 
     int ans1, ans2;
 
     int dbg = 0;
     
     for (k = 0; k < numTestCases; k++)
     {
     
     	// Read in input
 
     	fgets(buffer, 1024, fin);
     	sscanf(buffer, "%d", &ans1);
 
     	if(dbg)
     		printf("The row number chosen in first board is %d\n", ans1);
     		
     	for (int i = 0; i < 4; i++)
 		{
 			fgets(buffer, 1024, fin);
 			sscanf(buffer, "%d %d %d %d", &board1[i][0], &board1[i][1], &board1[i][2], &board1[i][3]);
 		}
 		
 		if (dbg)
 		{
 			for (i = 0; i < 4; i++)
 			{
 				printf("%d\t", board1[ans1-1][i]);
 			}
 			printf("\n");
 		}
 
 		fgets(buffer, 1024, fin);
 		sscanf(buffer, "%d", &ans2);
 		
 		if (dbg)
 			printf("The row number chosen in the second board is %d\n", ans2 );
 
     	for (int i = 0; i < 4; i++)
 		{
 			fgets(buffer, 1024, fin);
 			sscanf(buffer, "%d %d %d %d", &board2[i][0], &board2[i][1], &board2[i][2], &board2[i][3]);
 		}
 
 		if (dbg)
 		{
 			for (i = 0; i < 4; i++)
 			{
 				printf("%d\t", board2[ans2-1][i]);
 			}
 			printf("\n");
 		}
 
 
 		// Compare the corresponding rows of the two boards.
 
 		int numEqual = 0;
 		int equal = 0;
 
 		int board_row1[4], board_row2[4];
 
 
 		copybuf(&board1[(ans1-1)][0], &board_row1[0]);
 		copybuf(&board2[(ans2-1)][0], &board_row2[0]);
 
 		if (dbg)
 		{
 			printf("The row copied from the first board  is\n");
 			for (i = 0; i < 4 ; i++)
 			{
 				printf("%d\t", board_row1[i]);
 			}
 			printf("\n");
 
 			printf("The row copied from the second board is\n");
 			for (i = 0; i < 4 ; i++)
 			{
 				printf("%d\t", board_row2[i]);
 			}
 			printf("\n");
 		}
 
 		for (i = 0; i < 4 ; i++)
 		{
 			for (int m = 0; m < 4; m++)
 			{
 				if (board_row1[i] == board_row2[m])
 				{
 					numEqual++;
 					equal = board_row1[i];
 					//printf("The element found is %d\n", equal );
 				}
 			}
 		}
 
 		//printf("numEqual = %d\n", numEqual);
 
 		if (numEqual == 0)
 			printf("Case #%d: Volunteer cheated!\n", k+1 );
 		else if (numEqual == 1)
 			printf("Case #%d: %d\n", k+1, equal );
 		else
 			printf("Case #%d: Bad magician!\n", k+1 );
 
 		
     }
 
     fclose(fin);
 	return 0;
 }
 
 void copybuf(int *s, int *d)
 {
 	int i;
 	for (i = 0; i < 4; i++)
 	{
 		*(d + i) = *(s + i);
 	}
 }
 
 
