//
 //  main.c
 //  MagicTrick
 //
 //  Created by Mohamed Saad on 4/12/14.
 //  Copyright (c) 2014 Mohamed Saad. All rights reserved.
 //
 
 #include <stdio.h>
 
 FILE *input;
 FILE *output;
 
 void readRowAtIndex(int r, int *b)
 {
     for (int i=0 ; i<4 ; i++)
     {
         for (int j=0 ; j<4 ; j++)
         {
             int card = 0;
             fscanf(input, "%d", &card);
             if (r-1 == i)
             {
                 b[j] = card;
             }
         }
     }
 }
 
 int getMatches(int *b1, int *b2, int *match)
 {
     int matchesCount = 0;
     for (int i=0; i<4 ; i++)
     {
         for (int j=0 ; j<4 ; j++)
         {
             if (b1[i]==b2[j])
             {
                 *match = b1[i];
                 matchesCount++;
             }
         }
     }
     return matchesCount;
 }
 
 void startTestCase(int testCaseNumber)
 {
     int s1 = 0, s2 = 0;
     int b1[4], b2[4];
     
     fscanf(input, "%d",&s1);
     readRowAtIndex(s1, b1);
     
     fscanf(input, "%d",&s2);
     readRowAtIndex(s2, b2);
     
     int match = 0;
     int count = getMatches(b1,b2,&match);
     
     if (count == 1)
     {
         fprintf(output, "Case #%d: %d\n",testCaseNumber,match);
     }
     else if (count < 1)
     {
         fprintf(output, "Case #%d: Volunteer cheated!\n",testCaseNumber);
     }
     else if (count > 1)
     {
         fprintf(output, "Case #%d: Bad magician!\n",testCaseNumber);
     }
 }
 
 void start()
 {
     input = fopen("a.in", "r");
     output = fopen("a.out", "w");
     
     int testCases = 0;
     fscanf(input, "%d",&testCases);
     for (int i=1 ; i<= testCases ; i++)
     {
         startTestCase(i);
     }
     
     fclose(input);
     fclose(output);
 }
 
 int main(int argc, const char * argv[])
 {
     start();
     return 0;
 }
 
