//
 //  main.c
 //  MagicTrick
 //
 //  Created by Benjamin de Callatay on 12/04/14.
 //  Copyright (c) 2014 Benjamin de Callatay. All rights reserved.
 //
 
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 
 int main(int argc, const char * argv[])
 {
     // Ouverture fichier
     FILE *fichier = fopen("/Users/bendecall/Desktop/A-small-attempt0.in", "r");
     if (!fichier)
     {
         printf("Impossible d'ouvrir le fichier!\n");
         return -1;
     }
     
     // Lecture premiere ligne
     char ligne [ 1024 ]; /* Peut-être plus long si nécessaire */
     if (!fgets ( ligne, sizeof ligne, fichier )){
         printf("Impossible de lire l'entete du fichier!\n");
         return -1;
     }
     int nombreDeTests = atoi(ligne);
     
 //    printf("Nombre de test: %i\n", nombreDeTests);
     
     
     // On boucle sur le nombre de tests
     int i;
     for (i=0; i<nombreDeTests; i++) {
 //        printf("TEST #%i\n", (i+1));
         
         //----------
         // TEST #i
         //----------
         // Boucle sur les manches (1 et 2)
         int tab[2][4];  //tableau contenant les 2 lignes selectionnées
 
         int k;
         for (k=0; k<2; k++) {
             if (!fgets ( ligne, sizeof ligne, fichier )){
                 printf("Impossible de lire l'entete de la partie 1 du test #%i!\n", i);
                 return -1;
             }
             int numeroDeLigne = atoi(ligne);
             
 //            printf("Numéro de ligne: %i\n", numeroDeLigne);
             
             // On boucle sur les lignes du test
             int j;
             for (j=0; j<4; j++) {
                 if (!fgets ( ligne, sizeof ligne, fichier )){
                     printf("Impossible de lire la ligne %i du test #%i!\n", j, i);
                     return -1;
                 }
                 
                 // Bonne ligne
                 if (numeroDeLigne == (j+1)) {
                     char *temp = strtok(ligne, " ");
                     tab[k][0] = atoi(temp);
  //                   printf("- %i\n", tab[k][0]);
 
                     int l = 1;
                     while ( (temp = strtok(NULL, " ")) != NULL ) {
                         tab[k][l] = atoi(temp);
  //                       printf("- %i\n", tab[k][l]);
                         l++;
                     }
                 }
             }
         }
         
         // VERIFICATION
         printf("CASE #%i: ", (i+1));
         
         
         int m;
         int lastNB = -1;
         int stop = 0;
         
         for (m=0; m<4; m++) {
             int n;
             for (n=0; n<4; n++) {
                 if (tab[0][m] == tab[1][n]){
                     if (stop == 0) {
                         if (lastNB == -1){
                             lastNB = tab[0][m];
                         } else {
                             printf("Bad magician!\n");
                             lastNB = -2;
                             stop = 1;
                         }
                     }
                 }
             }
         }
         if (lastNB == -1) {
             printf("Volunteer cheated!\n");
         } else {
             if (lastNB != -2) {
                 printf("%i\n", lastNB);
             }
         }
     }
     
     
     fclose(fichier);
     return 0;
     
     
 }
 
