#include <stdio.h>
 
 // Returns 0 if more than one coincidence, 
 // [1,16] if only one coincidence and 
 // -1 if no coincidence
 int compare(int* v1, int *v2)
 {
 	int i1, i2;
 	int res = -1;
 
 	for (int i1 = 0; i1 < 4; ++i1)
 		for (int i2 = 0; i2 < 4; ++i2)
 			if (v1[i1] == v2[i2]) {
 				if (res > 0)
 					return 0;
 				else
 					res = v1[i1];
 			}
 
 	return res;
 }
 
 void read(int* values)
 {
 	int ans;
 	int row;
 	int trash[4];
 
 	scanf("%d\n", &ans);
 	for (row = 1; row <= 4; ++row)
 		if (row == ans)
 			scanf("%d %d %d %d\n", values, values+1, values+2, values+3);
 		else
 			scanf("%d %d %d %d\n", trash, trash+1, trash+2, trash+3);
 }
 
 int main(int argc, char const *argv[])
 {
 	
 	int T, iT;
 	int values1[4], values2[4];	
 	int result;
 
 	scanf("%d\n", &T);
 
 	for (iT = 1; iT <= T; ++iT)
 	{
 		read(values1);
 		read(values2);
 
 		result = compare(values1, values2);
 
 		printf("Case #%d: ", iT);
 		if (!result)
 			printf("Bad magician!\n");
 		else if (result == -1)
 			printf("Volunteer cheated!\n");
 		else
 			printf("%d\n", result);
 	}
 
 	return 0;
 }