//
 //  main.c
 //  HelloWorld
 //
 //  Created by MAC on 2014/4/11.
 //  Copyright (c) 2014 Steve Ho. All rights reserved.
 //
 
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 
 int getNumCases( FILE *afptr );
 void readNextCase( FILE *aFptr, int *aFirstRow, int a1[4][4], int *aSecondRow, int a2[4][4] );
 void answer( const int aFirstRow, const int a1[4][4], const int aSecondRow, const int a2[4][4] );
 
 int main(int argc, const char * argv[])
 {
     FILE *fptr;
     fptr = fopen("./A-small-attempt0.in", "r");
     
     if (!fptr) {
         printf("ReadFile fails.\n");
         return 0;
     }
     
     int num = getNumCases( fptr );
     
     if(!num ) {
         printf("Zero case.\n");
         return 0;
     }
     else
     {
 //        printf("num: %d\n", num );
     }
     
     /* Read case and run algo. */
     int i = 0;
     //int j = 0;a
     int firstRow = 0;
     int secondRow = 0;
     int A1[4][4]={0};
     int A2[4][4]={0};
     for( i = 0; i < num; i++ )
     {
         /* Read data */
         firstRow = 0;
         secondRow = 0;
         memset( A1, 0, ( sizeof( int ) * 16 ) );
         memset( A2, 0, ( sizeof( int ) * 16 ) );
         readNextCase( fptr, &firstRow, A1, &secondRow, A2 );
         printf( "Case #%d: ", i+1 );
         answer( firstRow-1, A1, secondRow-1, A2 );
         if( i != num -1 )
         {
             printf( "\n" );
         }
     }
     
     fclose(fptr);
     return 0;
 }
 
 int getNumCases( FILE *afptr )
 {
     int num = 0;
     fscanf( afptr, "%d%*c", &num );
     return num;
 }
 
 void readNextCase( FILE *aFptr, int *aFirstRow, int a1[4][4], int *aSecondRow, int a2[4][4] )
 {
     int i = 0;
     int j = 0;
     
     fscanf( aFptr, "%d", aFirstRow );
 //    printf("1row: %d\n", *aFirstRow);
     for( i = 0; i < 4; i++ )
     {
         for( j = 0; j < 4; j++ )
         {
             fscanf( aFptr, "%d", &a1[i][j] );
 //            printf("%d ", a1[i][j]);
         }
 //        printf("\n");
     }
 
     fscanf( aFptr, "%d ", aSecondRow );
 //    printf("2row: %d\n", *aSecondRow);
     for( i = 0; i < 4; i++ )
     {
         for( j = 0; j < 4; j++ )
         {
             fscanf( aFptr, "%d", &a2[i][j] );
 //            printf("%d ", a2[i][j]);
         }
 //        printf("\n");
     }
 }
 
 void answer( const int aFirstRow, const int a1[4][4], const int aSecondRow, const int a2[4][4] )
 {
     int i = 0;
     int j = 0;
     int hit = 0;
     int answer = 0;
     
     for( i = 0 ; i < 4; i++ )
     {
         for( j = 0; j < 4; j++ )
         {
 //            printf("a1[%d][%d]:%d a2[%d][%d]:%d\n", aFirstRow, i, a1[aFirstRow][i], aSecondRow, j, a2[aSecondRow][j] );
             if( a1[aFirstRow][i] == a2[aSecondRow][j] )
             {
                 if( !hit )
                 {
                     answer = a1[aFirstRow][i];
                 }
                 hit++;
             }
         }
     }
     
     if( hit == 0 )
     {
         printf( "Volunteer cheated!" );
     }
     else if( hit == 1 )
     {
         printf( "%d", answer );
     }
     else
     {
         printf( "Bad magician!" );
     }
     
     return;
 }