//2010 Google Code Jam - Round 1B - B. Picking Up Chicks
 #include <iostream>
 #include <fstream>
 #include <vector>
 #include <string>
 #include <algorithm>
 #include <cmath>
 
 using namespace std;
 
 bool CanReachBarn(int location, int velocity, int barn, int timeLimit)
 {
 	return (velocity * timeLimit + location >= barn) ? true : false;
 }
 
 int main()
 {
 	//Open files
 	//ifstream fin("I:\\GoogleCodeJam\\sampleData.in");
 	ifstream fin("I:\\GoogleCodeJam\\B-small-attempt2.in");
 	//ifstream fin("I:\\GoogleCodeJam\\A-large.in");
 	ofstream fout("I:\\GoogleCodeJam\\output.txt");
 
 	if(!fin)
 	{    
 		cout << "File loading fails." << endl;   
 	}
 
 	int cases; 
 
 	fin >> cases;
 
 	//Handle Input
 	for (int caseNumber = 1;caseNumber <= cases;++caseNumber)
 	{
 		int n, passChicks, barn, timeLimit;
 
 		fin >> n >> passChicks >> barn >> timeLimit;
 
 		int location[50];
 		int velocity[50];
 
 		for (int i = 0;i < n;i++)
 		{
 			fin >> location[i];
 		}
 
 		for (int i = 0;i < n;i++)
 		{
 			fin >> velocity[i];
 		}
 
 		//Main algo.
 		int swapCount = 0;
 		int finalChickCount = 0;
 
 		for (int i = n - 1;i >= 0 && finalChickCount < passChicks;i--)
 		{
 			if (CanReachBarn(location[i], velocity[i], barn, timeLimit))
 			{
 				finalChickCount++;
 			}
 			else
 			{
 				bool passFlag = false;
 
 				for (int j = i - 1;j >= 0;j--)
 				{
 					if (CanReachBarn(location[i], velocity[j], barn, timeLimit))
 					{
 						//Swap
 						for (int k = j;k < i;k++)
 						{
 							int temp = velocity[k];
 							velocity[k] = velocity[k + 1];
 							velocity[k + 1] = temp;
 
 							swapCount++;
 						}
 
 						finalChickCount++;
 
 						passFlag = true;
 
 						break;
 					}
 				}
 
 				if (!passFlag)
 					break;
 			}
 		}
 
 		if (finalChickCount == passChicks)
 		{
 			//Output
 			fout << "Case #" << caseNumber << ": " <<  swapCount << endl;	
 		}
 		else
 		{
 			//Output
 			fout << "Case #" << caseNumber << ": IMPOSSIBLE" << endl;	
 		}
 		
 	
 	}
 	
 	//Close files
 	fin.close();   
 	fout.close();
 
 	return 0;
 }