#include <iostream>
 #include <algorithm>
 #include <fstream>
 #include <string>
 #include <map>
 #include <cmath>
 using namespace std;
 ifstream fin("B-small.in");
 ofstream fout("B-small.out");
 
 class chick {
   public:
     int pos;
     int spd;
     int swaps;
     bool awesome;
 };
 
 bool operator<(const chick& d1, const chick&d2) {
   if (!d1.awesome && d2.awesome) return false;
   if (d1.awesome && !d2.awesome) return true;
   return d1.swaps < d2.swaps;
 }
 
 chick set[100];
 
 int main() {
   long long num;
   long long chicks;
   long long req_chicks;
   long long dist;
   long long time;
   fin >> num;
   for (int i = 0; i < num; i++) {
     long long awesome_cnt = 0;
     fin >> chicks >> req_chicks >> dist >> time;
     for (int j = 0; j < chicks; j++) {
       fin >> set[j].pos;
     }
     for (int j = 0; j < chicks; j++) {
       fin >> set[j].spd;
       set[j].awesome = (set[j].pos + set[j].spd * time) >= dist;
       if (set[j].awesome) awesome_cnt++;
       set[j].swaps = 0;
     }
     
     for (int j = 0; j < chicks && awesome_cnt > req_chicks; j++) {
       if (set[j].awesome) {
         set[j].awesome = false;
         awesome_cnt--;
       }
     }
     
     for (int j = 0; j < chicks; j++) {
       if (!set[j].awesome) continue;
       for (int k = j+1; k < chicks; k++) {
         if (set[k].spd < set[j].spd) {
           int posdiff = set[k].pos - set[j].pos;
           int vdiff = set[j].spd - set[k].spd;
           double impact_time = (double) posdiff / (double) vdiff;
           double impact_loc = (double) set[j].pos + impact_time * (double) set[j].spd;
           if (!set[k].awesome || impact_time < time && impact_loc < dist) {
             set[j].swaps++;
           }
         }
         else if (!set[k].awesome) {
           set[j].swaps++;
         }
       }
     }
     
     sort(set, set+chicks);
     long long swaps = 0;
     for (int j = 0; j < req_chicks; j++) {
       if (!set[j].awesome) {
         swaps = -1;
         break;
       }
       else {
         swaps += set[j].swaps;
       }
     }
     
     if (swaps == -1) {
       fout << "Case #" << i+1 << ": IMPOSSIBLE" << endl;
     }
     else {
       fout << "Case #" << i+1 << ": " << swaps << endl;
     }
   }
   return 0;
 }
