#include "stdio.h"
 #include "stdlib.h"
 #include "math.h"
 #include "string.h"
 
 /* est-ce que tu est sûr de ta première condition ? si C*R%X == 0 richard peux gagner quand même */
 
 #define PRINT(VAR) printf(#VAR " : %d\n", VAR)
 #define NB_ELEMS 1000
 
 int gabrielPeutGagner(int nbCases, int nbLignes, int nbColonnes) {
   int minBordure, maxBordure;
 
   if(nbCases > 7) return 0;
 
   if(nbLignes < nbColonnes) {
     minBordure = nbLignes;
     maxBordure = nbColonnes;
   } else {
     minBordure = nbColonnes;
     maxBordure = nbLignes;
   }
   /* printf("Test avec %d cases, %d lignes, %d colonnes\n", nbCases, nbLignes, nbColonnes); */
 
   if((nbLignes * nbColonnes) % nbCases != 0) {
     return 0;
   }
 
   if(maxBordure >= nbCases && minBordure >= nbCases - 1) {
     return 1;
   }
 
   
   return 0;
 }
 
 int main() {
   char buf[5000], *p;
   int nbTests, nbCases, nbLignes, nbColonnes;
   int i;
 
   /* Lire ligne 1 : nb de tests */
   if(gets(buf) == NULL) {
     perror("gets");
     exit(1);
   }
   /* Parser le nb de tests */
   nbTests = atoi(buf);
   /* PRINT(nbTests); */
   
   /* Faire tous les tests */
   for(i=0; i<nbTests; i++) {
 
     /* Lire ligne 2 : X R C */
     if(gets(buf) == NULL) {
       perror("gets");
       exit(1);
     }
 
     p = buf;
 
     /* Parser le nombre de cases */
     nbCases = atoi(p);
     p = index(p, ' ') + 1;
     /* PRINT(nbCases); */
     
     /* Parser le nombre de lignes */
     nbLignes = atoi(p);
     p = index(p, ' ') + 1;
     /* PRINT(nbLignes); */
     
     /* Parser le nombre de colonnes */
     nbColonnes = atoi(p);
     p = index(p, ' ') + 1;
     /* PRINT(nbColonnes); */
 
     /* Qui gagne ? */
     printf("Case #%d: %s\n", i+1, (gabrielPeutGagner(nbCases, nbLignes, nbColonnes)) ? "GABRIEL" : "RICHARD");
   }
 
   return 0;
 }
 
