
 #include <cstdio>
 #include <iostream>
 #include <iomanip>
 #include <sstream>
 #include <cstdlib>
 #include <cmath>
 #include <ctime>
 #include <cctype>
 #include <cstring>
 #include <string>
 #include <vector>
 #include <deque>
 #include <queue>
 #include <stack>
 #include <list>
 #include <set>
 #include <map>
 #include <limits>
 #include <utility>
 #include <numeric>
 #include <iterator>
 #include <algorithm>
 using namespace std;
 
 const int INF=(1<<30)-1;
 const long long LINF=(1ll<<62)-1;
 const int DIRX[]={-1,0,0,1,-1,-1,1,1}, DIRY[]={0,-1,1,0,-1,1,-1,1};
 const double ERR=1e-11, PI=(2*acos(0.0));
 
 #define min(a,b) ((a)<(b)?(a):(b))
 #define max(a,b) ((a)<(b)?(b):(a))
 template<class T> inline T MIN(T a,T b) {return ((a<b)?(a):(b));}
 template<class T> inline T MAX(T a,T b) {return ((b<a)?(a):(b));}
 template<class T> inline T ABS(T a) {return ((a<0)?(-a):(a));}
 template<class T> inline void checkMIN(T& a,T b) {if(b<a) a=b;}
 template<class T> inline void checkMAX(T& a,T b) {if(a<b) a=b;}
 template<class T> inline T SQR(T x) {return (x*x);}
 template<class T> inline T GCD(T a,T b) {T c; while((c=a%b)!=0)a=b,b=c; return b;}
 template<class T> inline T fastPow(T Base,T Power) {T Result=1; while(Power>0){if(Power&1)Result*=Base; Power>>=1; Base*=Base;} return Result;}
 template<class T> inline T fastModPow(T Base,T Power,T Mod) {T Result=1;while(Power>0){if(Power&1)Result=(Result*Base)%Mod; Power>>=1; Base=(Base*Base)%Mod;} return (Result%Mod);}
 inline int compDouble(double x,double y) {double d=x-y; if(d-ERR>0.0) return 1; else if(d+ERR<0.0) return -1; else return 0;}
 
 #define ALL(X)       (X).begin(),(X).end()
 #define SIZE(X)      ((int)(X).size())
 #define MEM(X,with)  memset((X),(with),sizeof(X))
 #define EACH(X,itr)  for( __typeof((X).begin()) itr=(X).begin(); itr!=(X).end(); itr++)
 #define Contains(X,item)    ((X).find(item)!=(X).end())
 #define Contains_n(X,item)	(find((X).begin(),(X).end(),(item))!=(X).end())
 
 typedef unsigned long long ULL;
 typedef long long      LL;
 typedef stringstream   SS;
 typedef vector<string> VS;
 typedef vector<double> VD;
 typedef vector<LL>     VL;
 typedef vector<int>    VI;
 typedef pair<int,int>  Pii;
 
 bool f(int x,int r,int c) {
     if(r*c%x) return false;
 
     if(x==1) return true;
 
     if(x==2) return true;
 
     if(x==3) {
         if(r==1) return false;
         return true;
     }
 
     if(x==4) {
         if(r==1) return false;
         if(r==2) return false;
         return true;
     }
 
     if(x==5) {
         if(r==1) return false;
         if(r==2) return false;
         if(r==3 && c==5) return false;
         return true;
     }
 
     if(x==6) {
         if(r==1) return false;
         if(r==2) return false;
         if(r==3) return false;
         return true;
     }
 
     return false;
 }
 
 int main()
 {
 //	freopen("in.txt","r",stdin);
 	freopen("D-large.in","r",stdin);
 	freopen("out.txt","w",stdout);
 
 	int cases,caseno;
 	int x,r,c;
 	scanf("%d",&cases);
 	for(caseno=1;caseno<=cases;caseno++) {
         scanf(" %d %d %d",&x,&r,&c);
         bool ans=f(x,min(r,c),max(r,c));
         printf("Case #%d: %s\n",caseno,ans?"GABRIEL":"RICHARD");
 	}
 
 	return 0;
 }
