//
 //  main.c
 //  Magic Trick
 //
 //  Created by Austin Rhodes on 4/11/14.
 //  Copyright (c) 2014 Austin Rhodes. All rights reserved.
 //
 
 #include <stdio.h>
 #define FILEPATH "/Users/austinrhodes/Downloads/A-small-attempt1.in"
 #define OUTPUT "/Users/austinrhodes/Desktop/Magic Trick.txt"
 
 int main(int argc, const char * argv[])
 {
     FILE * fp_in, * fp_out;
     fp_in = fopen(FILEPATH, "r");
     if(fp_in == NULL){
         fprintf(stderr, "Error opening input!\n");
     }
     fp_out = fopen(OUTPUT, "w");
     if(fp_out == NULL){
         fprintf(stderr, "Error opening output!\n");
     }
     int T, i, j;
     fscanf(fp_in, "%d ", &T);
     for(i = 0; i < T; i++){
         int ans1, ans2, solution, common_flag = 0;
         int board1[4][4] = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
         int board2[4][4] = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
         //find answer 1
         fscanf(fp_in, "%d ", &ans1);
         //scan in first arrangement
         for(j = 0; j < 4; j++){
             fscanf(fp_in, "%d %d %d %d",&board1[j][0],&board1[j][1],&board1[j][2],&board1[j][3]);
         }
         //find answer 2
         fscanf(fp_in, "%d ", &ans2);
         //scan in second arrangement
         for(j = 0; j < 4; j++){
             fscanf(fp_in, "%d %d %d %d",&board2[j][0],&board2[j][1],&board2[j][2],&board2[j][3]);
         }
         //check for element in common to both 'answer' rows
         for(j = 0; j < 4; j++){
             if(board1[ans1 - 1][0] == board2[ans2 - 1][j]){
                 //common found
                 printf("common found in check %d\n",j+1);
                 common_flag++;
                 solution = board1[ans1 - 1][0];
             }
             else if(board1[ans1 - 1][1] == board2[ans2 - 1][j]){
                 //common found
                 printf("common found in check %d\n",j+1);
                 common_flag++;
                 solution = board1[ans1 - 1][1];
             }
             else if(board1[ans1 - 1][2] == board2[ans2 - 1][j]){
                 //common found
                 printf("common found in check %d\n",j+1);
                 common_flag++;
                 solution = board1[ans1 - 1][2];
             }
             else if(board1[ans1 - 1][3] == board2[ans2 - 1][j]){
                 //common found
                 printf("common found in check %d\n",j+1);
                 common_flag++;
                 solution = board1[ans1 - 1][3];
             }
         }
         if(common_flag > 1){
             //player cheated
             fprintf(fp_out, "Case #%d: Bad magician!\n", i+1);
         }
         else if(common_flag == 1){
             //magician found card
             fprintf(fp_out, "Case #%d: %d\n",i+1,solution);
         }
         else{
             //bad magician
             fprintf(fp_out, "Case #%d: Volunteer cheated!\n",i+1);
         }
     }
     return 0;
 }
 
