#include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 
 #define MAX_ROW 4
 #define MAX_COL 4
 
 static int a_read_table_calc_print(FILE *fp, int nth_TCase)
 {
 	int		i, j;
 	ssize_t		read;
 	size_t		len;
 	char		*line = NULL;
 	int		row1, row2;
 	int		Arr1[MAX_ROW][MAX_COL];
 	int		Arr2[MAX_ROW][MAX_COL];
 	int		ret = 0;
 	int		nMatch = 0,Magic_No, temp;
 	
 	if((read = getline(&line, &len, fp)) != -1)
 	{
 		row1 = atoi(line);
 	}
 	else
 	{
 		ret = -1;
 		goto f;
 	}
 
 	for(i = 0; i < MAX_ROW; i++)
 	{
         	if((read = getline(&line, &len, fp)) != -1)
         	{
                         for(j = 0; j < MAX_COL; j++)
                         {
                                 if(j == 0)
                                         Arr1[i][j] = atoi(strtok(line, " "));
                                 else
                                         Arr1[i][j] = atoi(strtok(NULL, " "));
                         }
                 
         	}
        		else
         	{
                 	ret = -1;
                 	goto f;
         	}
 	}
 
         if((read = getline(&line, &len, fp)) != -1)
         {
                 row2 = atoi(line);
         }
         else
         {
                 ret = -1;
                 goto f;
         }
 
 	for(i = 0; i < MAX_ROW; i++)
 	{
         	if((read = getline(&line, &len, fp)) != -1)
         	{
 			for(j = 0; j < MAX_COL; j++)
 			{
 				if(j == 0)
 					Arr2[i][j] = atoi(strtok(line, " "));
 				else
 					Arr2[i][j] = atoi(strtok(NULL, " "));
 			}
         	}
         	else
         	{
                 	ret = -1;
                 	goto f;
         	}
 	}
 	
 	for(i = 0; i < MAX_COL; i++)
 	{
 		temp = Arr1[row1 - 1][i];
 		for(j = 0; j < MAX_COL; j++)
 		{
 			if(temp == Arr2[row2 - 1][j])
 			{
 				Magic_No = temp;
 				nMatch++;
 			}
 		}
 	}
 
 	if(nMatch == 0)
 	{
 		printf("case #%d: Volunteer cheated!\n",nth_TCase);
 	}
 	else if(nMatch == 1)
 	{
 		printf("case #%d: %d\n",nth_TCase, Magic_No);
 	}
 	else
 	{
 		printf("case #%d: Bad magician!\n",nth_TCase);
 	}
 f:
 	if(line)
 		free(line);
 	return ret;
 }
 
 static int a_read_no_of_test_case(FILE *fp, int *nTCase)
 {
 	int 		ret = 0;
 	ssize_t		read;
 	size_t		len;
 	char		*line = NULL;
 
 	if((read = getline(&line, &len, fp)) != -1)
 	{
 		*nTCase = atoi(line);
 	}
 	else
 		ret = -1;
 	
 	if(line)	
 		free(line);
 
 	return ret;
 }
 
 int main(int argc, char *argv[])
 {
 	FILE 		*fp;
 	int		nTCase;
 	int		i;
 
 	if(argc < 2)
 	{
 		return -1;
 	}
 
 	fp = fopen(argv[1], "r");
 
 	if(fp == NULL) return -1;
 
 	if(a_read_no_of_test_case(fp, &nTCase) == -1) return -1;
 
 	for(i = 1; i <= nTCase; i++)
 	{
 		if(a_read_table_calc_print(fp, i) == -1) return -1;
 	}
 	
 	fclose(fp);
 	return 0;
 }
