/*
 To execute:
 <executable name> <input file name>
 */
 
 #include<stdio.h>
 
 enum state {
 	CHEAT,
 	BAD,
 	GO
 };
 
 int main (int argc, char* argv[]) {
 	FILE* fp;
 	FILE* fout;
 	int t, i, j, k, answer_row, match_count, number;
 	int a[5][5];
 	int answer[5];
 	enum state game;
 	char output[2][30] = {"Bad magician!", "Volunteer cheated!"};
 	
 	fp = fopen(argv[1], "r");
 	fout = fopen("magic_trick.out", "w");
 	fscanf(fp, "%d", &t);
 	
 	for (i = 0; i++ < t;) {
 		for (j = 0; j < 5; j++) answer[j] = 0;
 		
 		game = BAD;
 		match_count = 0;
 		
 		fscanf(fp, "%d", &answer_row);
 		for (j = 1; j <= 4; j++) {
 			for (k = 1; k <= 4; k++) {
 				fscanf(fp, "%d", &a[j][k]);
 				if (j == answer_row) answer[k] = a[j][k];
 			}
 		}
 		
 		fscanf(fp, "%d", &answer_row);
 		for (j = 1; j <= 4; j++) {
 			for (k = 1; k <= 4; k++) {
 				fscanf(fp, "%d", &a[j][k]);
 			}
 		}
 		
 		for (j = 1; j <= 4; j++) {
 			for (k = 1; k <= 4; k++) {
 				if (a[answer_row][j] == answer[k]) {
 					match_count++;
 					number = answer[k];
 					break;
 				}
 			}
 		}
 		
 		if (match_count == 1) {
 			fprintf(fout, "Case #%d: %d\n", i, number);
 		} else if (match_count == 0) {
 			fprintf(fout, "Case #%d: %s\n", i, output[1]);
 		} else {
 			fprintf(fout, "Case #%d: %s\n", i, output[0]);
 		}
 	}
 	
 	return 0;
 }