/*
 	Author : pavan itagi
 	Date   : 11/04/2014 
 */
 
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
 
 void getAnswersArray(int *answerArray);
 void computeTheValues(int *firstAnswerArray, int *secondAnswerArray, int testCase);
 
 int main(int argc, char const *argv[])
 {
 	int testCases;
 	scanf ("%d", &testCases);
 
 	int firstAnswerArray[4] = {0};
 	int secondAnswerArray[4]= {0};
 
 	for (int i = 0; i < testCases; ++i)
 	{
 		getAnswersArray(firstAnswerArray);
 		getAnswersArray(secondAnswerArray);
 		computeTheValues(firstAnswerArray, secondAnswerArray, i+1);
 	}
 	return 0;
 }
 
 void computeTheValues(int *firstAnswerArray, int *secondAnswerArray, int testCase)
 {
 	int foundValue = -1;
 	int numberOfValuesFound = 0;
 
 	for (int i = 0; i < 4; ++i)
 	{
 		int firstValue = firstAnswerArray[i];
 		for (int j = 0; j < 4; ++j)
 		{
 			int secondValue = secondAnswerArray[j];
 			if (firstValue == secondValue)
 			{
 				foundValue = firstValue;
 				numberOfValuesFound++;
 			}
 		}
 	}
 
 	if (numberOfValuesFound == 0)
 	{
 		// no values found
 		printf("case #%d: Volunteer cheated!\n", testCase);
 	}
 	else if (numberOfValuesFound == 1)
 	{
 		// cheated
 		printf("case #%d: %d\n", testCase, foundValue);
 	}
 	else
 	{
 		// bad value
 		printf("case #%d: Bad magician!\n", testCase);
 	}
 }
 
 void getAnswersArray(int *answerArray)
 {
 	int answer;
 	scanf ("%d", &answer);
 
 	int value;
 	for (int i = 0; i < 4; ++i)
 	{	
 		for (int j = 0; j < 4; ++j)
 		{
 			scanf ("%d", &value);
 			if (i == answer - 1)
 			{
 				answerArray[j] = value;
 			}
 		}
 	}
 }