#include <stdio.h>
 #include <stdlib.h>
 #include <unistd.h>
 #include <string.h>
 #include <strings.h>
 
 #define CHEAT -1
 #define BAD -2
 
 #define GRID_SIZE 16
 
 int test_case() {
 	int firstAnswerRow = 0, secondAnswerRow = 0;
 	int firstAnswerIdx = 0, secondAnswerIdx = 0;
 	int firstGrid[GRID_SIZE];
 	int secondGrid[GRID_SIZE];
 	int options[4];
 	scanf("%d", &firstAnswerRow);
 	firstAnswerRow--;
 	for(int i = 0; i < 16; ++i) {
 		scanf("%d", (&firstGrid[0] + i));
 	}
 	
 	scanf("%d", &secondAnswerRow);
 	secondAnswerRow--;
 	for(int i = 0; i < 16; ++i) {
 		scanf("%d", (&secondGrid[0] + i));
 	}
 	
 	int start = 4 * (firstAnswerRow); 
 	int stop = 4 * (firstAnswerRow + 1); 
 	for(int i = 0; start < stop; ++i, ++start) {
 		options[i] = firstGrid[start];
 	}
 	
 	start = 4 * (secondAnswerRow); 
 	stop = 4 * (secondAnswerRow + 1);
 	int foundOption = -1;
 	for(int i = 0; i < 4; ++i) {
 		int ii = start, iii = stop;
 		int opt = options[i];
 		while(ii < iii) {
 			if(secondGrid[ii] == opt) {
 				if(foundOption != -1) {
 					return BAD;
 				}
 				foundOption = opt;
 			}
 			++ii;
 		}
 	}
 	
 	return foundOption != -1 ? foundOption : CHEAT;
 }
 
 int main() {
   int testCases;
   scanf("%d", &testCases);
 	
 	for(int i = 0; i < testCases; ++i) {
 		int solve = test_case();
 		if(solve == BAD) {
 			printf("Case #%d: Bad magician!\n", i + 1);
 		}
 		else if(solve == CHEAT) {
 			printf("Case #%d: Volunteer cheated!\n", i + 1);
 		}
 		else {
 			printf("Case #%d: %d\n", i + 1, solve);
 		}
 	}
 }
